﻿using System.Collections.Generic;

namespace OrBit.MESInterface.Application.Contracts.ApiFile.Dtos
{
    public class UploadFileConfig
    {
        /// <summary>
        /// 允许上传的后缀名
        /// </summary>
        /// <value>The allow exts.</value>
        public HashSet<string> AllowExts { get; set; }

        /// <summary>
        /// 限制大小
        /// </summary>
        /// <value>The size of the limit.</value>
        public int? LimitSize { get; set; }

        /// <summary>
        /// 访问token
        /// </summary>
        /// <value>The access token.</value>
        public string AccessToken { get; set; }

        /// <summary>
        /// 下游上传地址配置
        /// </summary>
        public List<FileServers> FileServers { get; set; }
    }

    public class FileServers
    {  
        /// <summary>
        /// 服务器名称
        /// </summary>
        public string ServerName { get; set; }
        /// <summary>
        /// 请求地址
        /// </summary>
        public string Url { get; set; }
    }
}