using System.Threading.Tasks;
using OrBit.MESInterface.Infrastructure;

namespace OrBit.MESInterface.Application.Contracts.AppUpdata;

public interface IAppUpdataServer
{
    /// <summary>
    /// 获取操作系统驱动器
    /// </summary>
    /// <returns></returns>
    public Task<ExecutionResult> GetDriveInfo();
    
    /// <summary>
    /// 递归获取指定目录下的所文件与目录
    /// </summary>
    /// <param name="rootPath">入口目录</param>
    /// <returns></returns>
    public Task<ExecutionResult> GetAllDirectoryAndFileInfoAsync(string rootPath);

    /// <summary>
    /// 获取当前目录下的文件与目录
    /// </summary>
    /// <param name="rootPath">入口目录</param>
    /// <returns></returns>
    public Task<ExecutionResult> GetDirectoryAndFileInfoAsync(string rootPath);
}