﻿using OrBit.MESInterface.Domain.InterfaceConfiguration.Entities;
using System.Collections.Generic;

namespace OrBit.MESInterface.Application.Contracts.Dtos
{
    public class MESInterfaceConfigDto
    {
        public string Interface_Request_ConfigurationID { get; set; }

        /// <summary>
        /// 请求URL
        /// </summary>
        public string RequestURL { get; set; }

        /// <summary>
        /// 请求方法
        /// </summary>
        public string RequestMethod { get; set; }

        /// <summary>
        /// 工厂
        /// </summary>
        public string FactoryId { get; set; }

        /// <summary>
        /// 接口类型
        /// </summary>
        public string InterfaceType { get; set; }

        /// <summary>
        /// 是否需要权限验证
        /// </summary>
        public bool IsBasicAuth { get; set; }

        /// <summary>
        /// 类型描述
        /// </summary>
        public string InterfaceType_Describe { get; set; }

        /// <summary>
        /// 权限验证用户名
        /// </summary>

        public string AuthUserName { get; set; }

        /// <summary>
        /// 权限验证密码
        /// </summary>
        public string AuthPassword { get; set; }

        public IEnumerable<Interface_RequestHeader> _RequestHeaders { get; set; } = new List<Interface_RequestHeader>();
        public IEnumerable<Interface_Parameters> _RequestParameters { get; set; } = new List<Interface_Parameters>();
        public IEnumerable<Interface_Post_ServiceCode> _Post_ServiceCodes { get; set; } = new List<Interface_Post_ServiceCode>();

        public Interface_Post_ServiceCode _Post_ServiceCode { get; set; }
    }
}