﻿using Microsoft.Data.SqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OrBit.MESInterface.Application.Contracts.RemontRepositorie.Dto
{
    /// <summary>
    /// 命令类型
    /// </summary>
    public enum CommandType
    {
        /// <summary>
        /// sql
        /// </summary>
        SQL,
        /// <summary>
        /// 存储过程
        /// </summary>
        StoredProcedure
    }
    public class RemontRepositorieCommandInfoDto
    {
        public RemontRepositorieCommandInfoDto()
        {
            this.Parameters = new List<Parameter>();
        }
        /// <summary>
        /// 执行命令字符串
        /// </summary>
        public string CommandStr { get; set; }
        /// <summary>
        /// 命令类型
        /// </summary>
        public CommandType CommandType { get; set; }

        /// <summary>
        ///参数集合
        /// </summary>
        public List<Parameter> Parameters { get; set; }

        public override string ToString()
        {
           var sb = new StringBuilder();
            sb.AppendLine($"CommandStr:{CommandStr};");
            sb.AppendLine($"CommandType:{CommandType};");
            sb.AppendLine($"Parameter:");
            Parameters.ForEach(p =>
            {
                sb.AppendLine($"{p.ParameteName}:{p.ParameteValue},");
            });
            sb.AppendLine(";");

            return sb.ToString();
        }

        public string ParametersToString()
        {
            
            var sb = new StringBuilder();
            sb.AppendLine($"Parameter:");
            Parameters.ForEach(p =>
            {
                sb.AppendLine($"{p.ParameteName}:{p.ParameteValue},");
            });
            sb.AppendLine(";");

            return sb.ToString();
        }
        public SqlParameter[] GetSqlParameters()
        {
            SqlParameter[]sqlParameters = new SqlParameter[Parameters.Count];
            var index = 0;
            Parameters.ForEach(p =>
            {
                sqlParameters[index]=new SqlParameter(p.ParameteName, p.ParameteValue);
                index++;
            });

            return sqlParameters;
        }

    }
    /// <summary>
    /// 命令对应参数
    /// </summary>
    public class Parameter
    {
        /// <summary>
        /// 参数名称
        /// </summary>
        public string ParameteName { get; set; }
        /// <summary>
        /// 参数类型
        /// </summary>
        public string ParameteType { get; set; }

        /// <summary>
        /// 参数值
        /// </summary>
        public object  ParameteValue { get; set; }

       
    }
}
