﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OrBit.MESInterface.Application.Contracts.WGTask.Dtos
{
    public class TubeSetDataInfoDto
    {
        public TubeSetDataInfoDto()
        {
            Tubes = new List<TubeInfoDto>();
        }
        /// <summary>
        /// 项目号 默认值80240
        /// </summary>
        public string Project_ID { get; set; } = "80240";
        /// <summary>
        /// 版本默认值 "4.0"
        /// </summary>
        public string Version { get; set; } = "4.0";

        /// <summary>
        /// 默认值 tControl
        /// </summary>
        public string Software { get; set; } = "tControl";

        /***原材料信息**/
        /// <summary>
        /// 原材料管子长度
        /// </summary>
        public string LengthInLoading { get; set; }
        /// <summary>
        /// 吹气量（程序中来）
        /// </summary>
        public string TimeBlowOut { get; set; }
        /// <summary>
        /// 原材料管子个数
        /// </summary>
        public string NumberOfTubeSets { get; set; }
        /// <summary>
        /// 0(固定值)
        /// </summary>
        public string OptimizedUnloading { get; set; } = "0";

        /*info LastChangedBy*/
        /// <summary>
        /// 创建时间
        /// </summary>
        public string Time { get; set; } = DateTime.Now.ToString("MM.dd.yyyy HH:mm:ss");
        /// <summary>
        /// 文件名
        /// </summary>
        public string Name { get; set; } = "";
        /// <summary>
        /// 组合切管信息
        /// </summary>
        public List<TubeInfoDto> Tubes { get; set; }

        /// <summary>
        /// 是否切除100报废
        /// </summary>
        public bool Waste { get; set; }
    }
}
