﻿using Microsoft.Extensions.Logging;
using OrBit.MESInterface.Application.Contracts;
using OrBit.MESInterface.Application.Contracts.Dtos;
using OrBit.MESInterface.Application.Contracts.Interfaces;
using OrBit.MESInterface.Domain.InterfaceConfiguration.Repository;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using OrBit.MESInterface.Infrastructure;
using Volo.Abp;
using Volo.Abp.Application.Services;

namespace OrBit.MESInterface.Application.Service
{
    public class UploadinfoIDCheckService : ApplicationService, IUploadinfoIDCheckService
    {
        private readonly ILogger<UploadinfoIDCheckService> _logger;

        private readonly IInterface_Request_ConfigurationRepository _interface_Request_ConfigRepository;

        public UploadinfoIDCheckService( ILogger<UploadinfoIDCheckService> logger, IInterface_Request_ConfigurationRepository iInterface_Request_ConfigurationRepository)
        {
            _logger = logger;
            _interface_Request_ConfigRepository = iInterface_Request_ConfigurationRepository;
        }

        public async Task<ExecutionResult> FindUploadDataID(string InterfaceType, string InterfaceServiceName,string UploadID, CancellationToken cancellationToken=default)
        {
            ExecutionResult analyticResult = new ExecutionResult();
            analyticResult.code = ExecutionState.SUCCESS;
           var result =await _interface_Request_ConfigRepository.ExecuteStoredProcedureResultDataSet("InterfaceWebAPI_CheckUploadLogID",new Microsoft.Data.SqlClient.SqlParameter[] { new Microsoft.Data.SqlClient.SqlParameter("@UploadID", UploadID) });

            if (result == null || result.Tables.Count <= 0 || result.Tables[0].Rows.Count <= 0)
            {
                analyticResult.code = ExecutionState.FAIL;
                analyticResult.message = $"当前接口校验是否重复上次执行失败，请联系管理员";
                _logger.LogWarning($"当前接口校验是否重复上次执行失败，请联系管理员");

            }
          
            if(result.Tables[0].Rows[0]["ResultValue"].ToString()!=("0"))
            {
                analyticResult.code = ExecutionState.FAIL;
                analyticResult.message = $"当前{InterfaceType}接口{InterfaceServiceName}服务,{result.Tables[0].Rows[0]["ResultMSG"]}";
                _logger.LogWarning($"当前{InterfaceType}接口{InterfaceServiceName}服务,本次请求id{UploadID},{result.Tables[0].Rows[0]["ResultMSG"]}");
            }
             


            return analyticResult;

        }
    }
}
