﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.File.Entities
{
    public class APIFile : Entity
    {
        public APIFile()
        { }

        public string APIFileID { get; set; }

        /// <summary>
        /// 文件名
        /// </summary>
        public string FileName { get; set; }

        /// <summary>
        /// 文件描述
        /// </summary>
        public string FileDescription { get; set; }

        /// <summary>
        /// 文件类型
        /// </summary>
        public string ContentType { get; set; }

        /// <summary>
        /// 扩展名
        /// </summary>
        public string ExtensionName { get; set; }

        /// <summary>
        /// 文件大小
        /// </summary>
        public long Length { get; set; }

        /// <summary>
        /// 存储服务器名称
        /// </summary>
        public string StorageServerName { get; set; }

        /// <summary>
        /// 存储路径
        /// </summary>
        public string StoragePath { get; set; }

        /// <summary>
        /// 访问路径
        /// </summary>
        public string FileUrl { get; set; }

        /// <summary>
        /// 上传时间
        /// </summary>
        public DateTime? CreateTime { get; set; }

        /// <summary>
        /// 哈希值
        /// </summary>
        public string HashID { get; set; }

        /// <summary>
        /// 删除状态
        /// </summary>
        public bool Del { get; set; }

        /// <summary>
        /// 上传的用户
        /// </summary>
        public string UploadUser { get; set; }

        public DateTime? DelTime { get; set; }

        public override object[] GetKeys()
        {
            return new object[] { Guid.NewGuid().ToString() };
        }
    }
}