﻿using System;
using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.InterfaceConfiguration.Entities
{
    public class Interface_Post_ServiceCode : Entity
    {
        public Interface_Post_ServiceCode()
        {
        }

        /// <summary>
        /// pkid
        /// </summary>
        public string Interface_Post_ServiceCodeID { get; set; }

        public Interface_Request_Configuration Interface_Request_Configuration { get; set; }

        /// <summary>
        /// ppid
        /// </summary>
        public string Interface_Request_ConfigurationID { get; set; }

        /// <summary>
        /// 排序序号
        /// </summary>
        public int Sequence { get; set; }

        /// <summary>
        /// 接口服务名称
        /// </summary>
        public string InterfaceServiceName { get; set; }

        /// <summary>
        /// 接口服务描述
        /// </summary>
        public string InterfaceServiceDescribe { get; set; }

        /// <summary>
        /// 是否需要替换服务名称
        /// </summary>
        public bool IsReplaceInInterfaceServiceField { get; set; }

        /// <summary>
        /// 接口服务替换字段
        /// </summary>
        public string InterfaceServiceReplacementField { get; set; }

        /// <summary>
        /// 参数默认模板
        /// </summary>
        public string ParameterTemplate { get; set; }

        /// <summary>
        /// 填充模板数据的存储过程
        /// </summary>

        public string FillParameterTemplateByStoredProcedure { get; set; }

        /// <summary>
        /// 将数据保存到业务表的存储过程
        /// </summary>
        public string StoredProcedureToSaveDataToBusinessTable { get; set; }

        /// <summary>
        /// 是否需要转json
        /// </summary>
        public bool IsTableToJson { get; set; }

        /// <summary>
        /// 是否自动获取数据
        /// </summary>
        public bool IsAutoGetOrPutData { get; set; }

        /// <summary>
        /// 返回对象名称
        /// </summary>
        public string ResultObjectName { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime? CreateDate { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        public string CreateUserID { get; set; }

        /// <summary>
        /// 最后执行时间'
        /// </summary>
        public DateTime? LastQuerData { get; set; }

        public bool IsDel { get; set; }
        public DateTime? DelTime { get; set; }

        public string DelUser { get; set; }

        public override object[] GetKeys()
        {
            return new object[] { Guid.NewGuid().ToString() };
        }
    }
}