﻿using System;
using System.Collections.Generic;
using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.InterfaceConfiguration.Entities
{
    public class Interface_Request_Configuration : Entity
    {
        /// <summary>
        /// 接口请求配置表pkid
        /// </summary>
        public string Interface_Request_ConfigurationID { get; set; }

        /// <summary>
        /// 描述
        /// </summary>
        public string Interface_Request_Configuration_Describe { get; set; }

        /// <summary>
        /// 环境变量ID
        /// </summary>
        public string EnvironmentVariableid { get; set; }

        /// <summary>
        /// 请求URL
        /// </summary>
        public string RequestURL { get; set; }

        /// <summary>
        /// 请求方法
        /// </summary>
        public string RequestMethod { get; set; }

        /// <summary>
        /// 工厂
        /// </summary>
        public string FactoryId { get; set; }

        /// <summary>
        /// 是否删除
        /// </summary>
        public bool? IsDel { get; set; }

        /// <summary>
        /// 删除时间
        /// </summary>
        public DateTime? DelTime { get; set; }

        /// <summary>
        /// 删除人
        /// </summary>
        public string DelUser { get; set; }

        /// <summary>
        /// 接口类型
        /// </summary>
        public string InterfaceType { get; set; }

        /// <summary>
        /// 类型描述
        /// </summary>
        public string InterfaceType_Describe { get; set; }

        /// <summary>
        /// MES服务地址
        /// </summary>
        public string MESWebAPIUrl { get; set; }

        /// <summary>
        /// 是否需要权限验证
        /// </summary>
        public bool IsBasicAuth { get; set; }

        /// <summary>
        /// 权限验证用户名
        /// </summary>

        public string AuthUserName { get; set; }

        /// <summary>
        /// 权限验证密码
        /// </summary>
        public string AuthPassword { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime? CreateTime { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        public string CreateUserid { get; set; }

        public IEnumerable<Interface_RequestHeader> _RequestHeaders { get; set; } = new List<Interface_RequestHeader>();
        public IEnumerable<Interface_Parameters> _RequestParameters { get; set; } = new List<Interface_Parameters>();
        public IEnumerable<Interface_Post_ServiceCode> _Post_ServiceCodes { get; set; } = new List<Interface_Post_ServiceCode>();

        public override object[] GetKeys()
        {
            return new object[] { Guid.NewGuid().ToString() };
        }
    }
}