﻿using Microsoft.Extensions.Logging;
using OrBit.MESInterface.Domain.InterfaceConfiguration.Entities;
using OrBit.MESInterface.Domain.InterfaceConfiguration.Repository;
using OrBit.MESInterface.Infrastructure.Common;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Volo.Abp;
using Volo.Abp.Domain.Services;

namespace OrBit.MESInterface.Domain.InterfaceConfiguration.Service
{
   public class MESInterfaceConfigManager: DomainService
    {
        private readonly IInterface_Request_ConfigurationRepository _interface_Request_ConfigRepository;

        public MESInterfaceConfigManager(IInterface_Request_ConfigurationRepository interface_Request_ConfigRepository)
        {
            _interface_Request_ConfigRepository = interface_Request_ConfigRepository;
        }
        public async Task<Interface_Request_Configuration> FindAllInterfaceConfig(string InterfaceType, CancellationToken cancellationToken)
        {
            var Interface_Request_Config = await _interface_Request_ConfigRepository.GetAsync(Interface_Request_Config => Interface_Request_Config.InterfaceType.Equals(InterfaceType)
                                                        , true, cancellationToken);

            if (Interface_Request_Config == null)
                throw new UserFriendlyException($"没有获取到接口类型[{InterfaceType}]对应的配置数据", "-1", logLevel: LogLevel.Error);
            return Interface_Request_Config;
        }


        //public async Task<RequestData> BuildRequestDataByInterfaceTypeAsync(MESInterfaceConfigDto InterfaceConfig, DateTime QueryDateEnd, string RequestDataParameters, CancellationToken cancellationToken)
        //{
        //    var PostData = string.Empty;
        //    if (InterfaceConfig.RequestMethod.ToLower() == "post")
        //    {
        //        if (InterfaceConfig._Post_ServiceCode == null)
        //            throw new UserFriendlyException($"当前接口服务类型{InterfaceConfig._Post_ServiceCode.InterfaceServiceName}请求方法是{InterfaceConfig.RequestMethod}但是没有获取到对应的Post请求配置信息", "-1", logLevel: LogLevel.Error);

        //        if (string.IsNullOrEmpty(InterfaceConfig._Post_ServiceCode.FillParameterTemplateByStoredProcedure))
        //            throw new UserFriendlyException($"当前接口服务类型{InterfaceConfig._Post_ServiceCode.InterfaceServiceName}请求方法是{InterfaceConfig.RequestMethod}但是没有获取到对应的Post请求参数模板配置信息", "-1", logLevel: LogLevel.Error);

        //        if (string.IsNullOrEmpty(InterfaceConfig._Post_ServiceCode.ParameterTemplate))
        //            throw new UserFriendlyException($"当前接口服务类型{InterfaceConfig._Post_ServiceCode.InterfaceServiceName}请求方法是{InterfaceConfig.RequestMethod}但是没有获取到对应的Post请求参数模板", "-1", logLevel: LogLevel.Error);

        //        if (string.IsNullOrEmpty(InterfaceConfig._Post_ServiceCode.FillParameterTemplateByStoredProcedure))
        //            throw new UserFriendlyException($"当前接口服务类型{InterfaceConfig._Post_ServiceCode.InterfaceServiceName}请求方法是{InterfaceConfig.RequestMethod}但是没有获取到对应的Post请求参数填充模板存储过程", "-1", logLevel: LogLevel.Error);

        //        if (string.IsNullOrEmpty(InterfaceConfig._Post_ServiceCode.StoredProcedureToSaveDataToBusinessTable))
        //            throw new UserFriendlyException($"当前接口服务类型{InterfaceConfig._Post_ServiceCode.InterfaceServiceName}请求方法是{InterfaceConfig.RequestMethod}但是没有获取到对应的Post请求保存数据到业务表的存储过程", "-1", logLevel: LogLevel.Error);

        //        PostData = await GetDataForFillParameterTemplate(InterfaceConfig._Post_ServiceCode.ParameterTemplate, InterfaceConfig._Post_ServiceCode.FillParameterTemplateByStoredProcedure, InterfaceConfig._Post_ServiceCode.InterfaceServiceName, InterfaceConfig.Interface_Request_ConfigurationID, QueryDateEnd, RequestDataParameters);
        //    }

        //    //if(Request_Configdto._RequestParameters?.ToList().Count>0)
        //    //{
        //    //    Request_Configdto._RequestParameters.Select(p=>new {p.Interface_ParameterName,p. }).ToList().ToDictionary<string,string>
        //    //}

        //    var RequestHeaders = new Dictionary<string, string>();
        //    if (InterfaceConfig._RequestHeaders?.ToList().Count > 0)
        //    {
        //        RequestHeaders = InterfaceConfig._RequestHeaders.Select(p => new { p.RequestHeaderName, p.RequestHeaderValue })
        //            .ToDictionary(RequestHeader => RequestHeader.RequestHeaderName, RequestHeader => RequestHeader.RequestHeaderValue);
        //    }

        //    var _RequestData = new RequestData(InterfaceConfig.RequestURL, InterfaceConfig.RequestMethod, InterfaceConfig.IsBasicAuth, InterfaceConfig.AuthUserName,
        //                                        InterfaceConfig.AuthPassword, null, PostData, RequestHeaders
        //                                       );

        //    return _RequestData;
        //}


    }
}
