﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.MaterialGroup.Entities
{
    public class MaterialGroupInfo : Entity
    {
        public MaterialGroupInfo() { 
            MaterialGroupInfoTaskListInfos= new List<MaterialGroupInfoTaskListInfo>();
        }
        public override object[] GetKeys()
        {
            
            return new object[] { Guid.NewGuid().ToString() };
        }
        /// <summary>
        /// 组合生产pkid
        /// </summary>
        public string MaterialGroupInfoID { get; set; }

        /// <summary>
        /// 组合生产信息ID
        /// </summary>
        public string materialGroup_id { get; set; }
        /// <summary>
        /// 原材料ID
        /// </summary>
        public string materialId { get; set; }

        /// <summary>
        /// 原材料长度
        /// </summary>
        public string Length { get; set; }
        /// <summary>
        /// 原材料个数
        /// </summary>
        public int count { get; set; }
        /// <summary>
        /// 开始时间
        /// </summary>
        public string startTime { get; set; }

        /// <summary>
        /// 生产序号
        /// </summary>
        public int  productionSequence   { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime? CreateTime { get; set; }
        /// <summary>
        /// 是否被删除
        /// </summary>
        public bool? Del { get; set; }
        /// <summary>
        /// 修改时间
        /// </summary>
        public string ModifyTime { get; set; }

        /// <summary>
        /// 已下发状态
        /// </summary>
        public bool? PublishStatus { get; set; }
        /// <summary>
        /// 组合关系任务明细
        /// </summary>
        public IEnumerable<MaterialGroupInfoTaskListInfo> MaterialGroupInfoTaskListInfos { get; set; }
    }
}
