﻿using OrBit.MESInterface.Domain.MaterialGroup.Entities;
using OrBit.MESInterface.Domain.MesInterfaceConfiguration.Entities;
using OrBit.MESInterface.Infrastructure.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Volo.Abp.Domain.Repositories;

namespace OrBit.MESInterface.Domain.MaterialGroup.Repository
{
    public interface IMaterialGroupRepository : IExetenRepository, IRepository<MaterialGroupInfo>
    {
        /// <summary>
        /// 通过任务号获取组合关系ID
        /// </summary>
        /// <param name="moTaskName"></param>
        /// <returns></returns>
        Task<List<MaterialGroupInfo>> GetMaterialGroupInfoID(string moTaskName);
        /// <summary>
        /// 通过料号和设备获取需要下发的程序
        /// </summary>
        /// <param name="productName"></param>
        /// <param name="AssetNumber"></param>
        /// <returns></returns>
        Task<IEnumerable<ProcessStepProgramInfo>> QueryProgramListByProductNameAndAssetNumber(string productName, string AssetNumber);
    }
}
