﻿using Microsoft.Data.SqlClient;
using OrBit.MESInterface.Domain.MaterialGroup.Entities;
using OrBit.MESInterface.Domain.MaterialGroup.Repository;
using OrBit.MESInterface.Domain.RemontQuery.Entities;
using System.Collections.Generic;
using System.Threading.Tasks;
using Volo.Abp.Domain.Services;

namespace OrBit.MESInterface.Domain.MaterialGroup.Service
{
    public class MaterialGroupManaager:DomainService
    {
        private  readonly IMaterialGroupRepository materialGroupRepository;
        public MaterialGroupManaager(IMaterialGroupRepository materialGroupRepository)
        {
            this.materialGroupRepository = materialGroupRepository;
        }

        /// <summary>
        /// 获取要下发的任务 信息
        /// </summary>
        /// <param name="materialGroupid"></param>
        /// <returns></returns>
        public Task<MaterialGroupInfo> QueryMaterialGroupById(string materialGroupid)
        {
           return materialGroupRepository.GetAsync(mg=>mg.MaterialGroupInfoID.Equals(materialGroupid));
        }
        public  Task<IEnumerable<ProcessStepProgramInfo>> QueryProgramListByProductNameAndAssetNumber(string productName, string AssetNumber)
        {
            return materialGroupRepository.QueryProgramListByProductNameAndAssetNumber(productName, AssetNumber);
        }

        /// <summary>
        /// 获取下发任务地址
        /// </summary>
        /// <param name="assetNumber"></param>
        /// <returns></returns>
        public Task<EqAssetInfoSendTaskPathInfo> QueryEqAssetInfo(string assetNumber)
        {
            return materialGroupRepository.ExecuteSqlResultT<EqAssetInfoSendTaskPathInfo>("SELECT  ServerSendTaskPath,ServerSendProgramPath FROM dbo.sys_EqAssetInfo WHERE AssetNumber=@AssetNumber", [new Microsoft.Data.SqlClient.SqlParameter("@AssetNumber", assetNumber)]);
        }


        public Task<List<MaterialGroupInfo>> QueryMaterialGroupProdutLineInfoByMoTaskName(string moTaskName)
        {
          // materialGroupRepository.ExecuteStoredProcedure("",)

            return materialGroupRepository.GetMaterialGroupInfoID(moTaskName);
        }
    }
}
