using System;
using System.Collections.Generic;
using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.MesInterfaceConfiguration.Entities
{
    public class MESInterfaceConfigInfo : Entity
    {
        /// <summary>
        ///  PKID
        /// <summary>
        public string MESInterfaceConfigInfoID { get; set; }

        /// <summary>
        ///  url
        /// <summary>
        public string MesInterfaceUrl { get; set; }

        public string InterfaceConsumer { get; set; }
        public string ConsumerId { get; set; }

        /// <summary>
        /// 消费方密钥
        /// </summary>
        public string ConsumerSecret { get; set; }

        public string PermissionAuthenticationMethod { get; set; }

        /// <summary>
        ///  接口描述
        /// <summary>
        public string InterfaceDesc { get; set; }

        /// <summary>
        ///  用户名
        /// <summary>
        public string AuthUserName { get; set; }

        /// <summary>
        ///  密码
        /// <summary>
        public string AuthPassword { get; set; }

        /// <summary>
        ///  创建时间
        /// <summary>
        public DateTime CreateTime { get; set; }

        /// <summary>
        ///  创建人
        /// <summary>
        public string CreateUser { get; set; }

        /// <summary>
        ///  激活
        /// <summary>
        public bool Activation { get; set; }

        /// <summary>
        /// 是否允许上传
        /// </summary>
        public bool ActivationUpload { get; set; }

        /// <summary>
        /// 文件存放路径
        /// </summary>
        public string UploadFolder { get; set; }

        public IEnumerable<MESInterfaceServiceConfigInfo> MesInterfaceServiceConfigInfos { get; set; }

        public override object[] GetKeys()
        {
            return new object[] { Guid.NewGuid().ToString() };
        }
    }
}