using System;
using System.Collections.Generic;
using System.Reflection.Metadata;

using Volo.Abp.Domain.Entities;

namespace OrBit.MESInterface.Domain.MesInterfaceConfiguration.Entities
{
    public class MESInterfaceServiceConfigInfo : Entity
    {
        /// <summary>
        ///  PKID
        /// <summary>
        public string MESInterfaceServiceConfigInfoID { get; set; }

        /// <summary>
        ///  PPKID
        /// <summary>
        public string MESInterfaceConfigInfoID { get; set; }

        /// <summary>
        ///  服务名称
        /// <summary>
        public string InterfaceServiceName { get; set; }

        /// <summary>
        ///  描述
        /// <summary>
        public string InterfaceServiceDescribe { get; set; }

        /// <summary>
        ///  接口类型
        /// <summary>
        public string InterfaceType { get; set; }

        /// <summary>
        ///  是否以WebService的形式发布
        /// <summary>
        public bool IsWebService { get; set; }

        public string WebServiceUrl { get; set; }

        /// <summary>
        ///  脚本名称
        /// <summary>
        public string ScriptCodeName { get; set; }

        /// <summary>
        ///  是否激活
        /// <summary>
        public bool Activation { get; set; }

        /// <summary>
        ///  创建时间
        /// <summary>
        public DateTime CreateTime { get; set; }

        /// <summary>
        ///  创建人
        /// <summary>
        public char CreateUser { get; set; }

        public MESInterfaceConfigInfo MesInterfaceConfig { get; set; }

        public IEnumerable<MESInterfaceParametersConfig> MesInterfaceParameters { get; set; }

        public IEnumerable<MESInterfaceResultDataConfigInfo> MesInterfaceResultDataConfigInfos { get; set; }

        public override object[] GetKeys()
        {
            return new object[] { Guid.NewGuid().ToString() };
        }
    }
}