﻿using Microsoft.EntityFrameworkCore;
using OrBit.MESInterface.Domain.InterfaceConfiguration.Entities;
using System.Linq;
using OrBit.MESInterface.Domain.MesInterfaceConfiguration.Entities;
using OrBit.MESInterface.Domain.MaterialGroup.Entities;

namespace OrBit.MESInterface.EntityFrameworkCore.Extensions
{
    public static class InterfaceRequestConfigurationRepositoryExtensions
    {
        public static IQueryable<Interface_Request_Configuration> IncludeDetails(this IQueryable<Interface_Request_Configuration> queryable, bool include = true)
        {
            if (!include)
            {
                return queryable;
            }

            return queryable
                .Include(configuration => configuration._Post_ServiceCodes)
                .Include(configuration => configuration._RequestHeaders)
                .Include(configuration => configuration._RequestParameters);
        }
    }

    public static class MesInterfaceRequestConfigRepositoryExtensions
    {
        public static IQueryable<MESInterfaceConfigInfo> IncludeDetails(
        this IQueryable<MESInterfaceConfigInfo> queryable, bool include = true)
        {
            if (!include)
                return queryable;
            return queryable.Include(config =>

               config.MesInterfaceServiceConfigInfos.AsQueryable()
            //.Include(s => s.MesInterfaceParameters)
            //.Include(s => s.MesInterfaceResultDataConfigInfos).AsQueryable()
            )
            ;
        }

        public static IQueryable<MESInterfaceServiceConfigInfo> IncludeDetails(
                this IQueryable<MESInterfaceServiceConfigInfo> queryable, bool include = true)
        {
            if (!include)
                return queryable;

            return queryable.Include(config => config.MesInterfaceConfig)
                .Include(config => config.MesInterfaceParameters)
                .Include(config => config.MesInterfaceResultDataConfigInfos);
        }

        public static IQueryable<MaterialGroupInfo> IncludeDetails(this IQueryable<MaterialGroupInfo> queryable,bool include=true)
        {
            if(!include)
                return queryable;
            return queryable.Include(config => config.MaterialGroupInfoTaskListInfos.AsQueryable());
        }
    }
}