﻿using Microsoft.EntityFrameworkCore;
using OrBit.MESInterface.Domain.File.Entities;
using OrBit.MESInterface.Domain.InterfaceConfiguration.Entities;
using OrBit.MESInterface.Domain.MaterialGroup.Entities;
using OrBit.MESInterface.Domain.MesInterfaceConfiguration.Entities;
using OrBit.MESInterface.Domain.RemontQuery.Entities;
using OrBit.MESInterface.Domain.SysPlugIn.Entities;
using Volo.Abp.EntityFrameworkCore;
using Volo.Abp.EntityFrameworkCore.Modeling;

namespace OrBit.MESInterface.EntityFrameworkCore
{
    public class MesInterfaceDBContext : AbpDbContext<MesInterfaceDBContext>
    {
        public MesInterfaceDBContext(DbContextOptions<MesInterfaceDBContext> options) : base(options)
        {
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);

            modelBuilder.Entity<Interface_Parameters>()
                .Property(Parameters => Parameters.Interface_Request_ConfigurationID).HasColumnName("Interface_ConfigurationID");
            modelBuilder.Entity<Interface_Parameters>().ConfigureByConvention();
        }

        public DbSet<Interface_Parameters> Interface_Parameters { get; set; }

        public DbSet<Interface_Post_ServiceCode> Interface_Post_ServiceCode { get; set; }
        public DbSet<Interface_RequestHeader> Interface_RequestHeader { get; set; }
        public DbSet<Interface_Request_Configuration> Interface_Request_Configuration { get; set; }

        public DbSet<Interface_ResultDataConfigInfo> Interface_ResultDataConfigInfo { get; set; }

        public DbSet<MESInterfaceServiceConfigInfo> MesInterfaceServiceConfigInfo { get; set; }

        public DbSet<MESInterfaceParametersConfig> MESInterfaceParametersConfig { get; set; }

        public DbSet<MESInterfaceConfigInfo> MesInterfaceConfigInfo { get; set; }

        public DbSet<MESInterfaceResultDataConfigInfo> MesInterfaceResultDataConfigInfo { get; set; }
        public DbSet<APIFile> APIFile { get; set; }
        public DbSet<SysParameter> SysParameter { get; set; }

        public DbSet<MaterialGroupInfo> MaterialGroupInfo { get; set; }
        public DbSet<MaterialGroupInfoTaskListInfo> MaterialGroupInfoTaskListInfo { get; set; }

        public DbSet<RemontQuerylogs> RemontQuerylogs { get; set; }
    }
}