﻿using Microsoft.AspNetCore.Http;
using OrBit.MESInterface.Application.Contracts.Interfaces;
using System.Threading.Tasks;
using OrBit.MESInterface.Infrastructure;

namespace OrBit.MESInterface.HttpApi.Host.Base.Middleware
{
    public class UploadInfoIDCheckMiddleware
    {
        private readonly RequestDelegate _next;

        private readonly IUploadinfoIDCheckService _uploadinfoIDCheckService;

        //  private readonly IServiceScope _serviceScope;
        public UploadInfoIDCheckMiddleware(RequestDelegate next, IUploadinfoIDCheckService uploadinfoIDCheckService) //IServiceScope serviceScope)
        {
            _next = next;
            //   _serviceScope = serviceScope;
            _uploadinfoIDCheckService = uploadinfoIDCheckService;//serviceScope.ServiceProvider.GetService<IUploadinfoIDCheckService>();
        }

        public async Task InvokeAsync(HttpContext context)
        {
            if (context.Request.Path.Value.Equals("/api/OrBitMesInterface/Gateway"))
            {
                if (!context.Request.Query.ContainsKey("UploadID"))
                {
                    context.Response.StatusCode = 400;
                    await context.Response.WriteAsJsonAsync(ExecutionResult.Failed("没有参数：UploadID"), typeof(ExecutionResult));
                    return;
                }

                if (!context.Request.Query.ContainsKey("InterfaceType"))
                {
                    context.Response.StatusCode = 400;
                    await context.Response.WriteAsJsonAsync(ExecutionResult.Failed("没有参数：InterfaceType"), typeof(ExecutionResult));
                    return;
                }

                if (!context.Request.Query.ContainsKey("InterfaceServiceName"))
                {
                    context.Response.StatusCode = 400;
                    await context.Response.WriteAsJsonAsync(ExecutionResult.Failed("没有参数：InterfaceServiceName"), typeof(ExecutionResult));
                    return;
                }
                string UploadID = context.Request.Query["UploadID"];
                string InterfaceType = context.Request.Query["InterfaceType"];
                string InterfaceServiceName = context.Request.Query["InterfaceServiceName"];

                if (InterfaceType != "Download")
                {
                    var result = await _uploadinfoIDCheckService.FindUploadDataID(InterfaceType, InterfaceServiceName, UploadID);
                    if (result.code != ExecutionState.SUCCESS)
                    {
                        await context.Response.WriteAsJsonAsync(result, typeof(ExecutionResult));

                        return;
                    }
                }
            }

            await _next(context);
        }
    }
}