using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using OrBit.MESInterface.EntityFrameworkCore;

namespace OrBit.MESInterface.HttpApi.Host
{
    public class Startup
    {
        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            var Configuration = services.GetConfiguration();
            services.AddDbContextPool<MesInterfaceDBContext>(options => options.UseSqlServer(Configuration.GetConnectionString(Configuration.GetSection("ActivationConnectionStrings")?.Value)));

            services.AddApplication<MESIntefaceHttpApiHostModule>();
            //   services.AddApplication<AbpModule>(options => options.UseAutofac());
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            app.InitializeApplication();
        }
    }
}