﻿using OrBit.MESInterface.Infrastructure.SQLTemplate;
using System;

namespace OrBit.MESInterface.Infrastructure
{
    public class BuildTableSqlService : IBuildTableSqlService
    {
        private string CreateTableSql = string.Empty;
        private string PrimarykeySql = string.Empty;
        private string ColumnSql = string.Empty;
        private string SettingColumnDescriptionsql = string.Empty;
        private string DefaultValueSQL = string.Empty;

        private string TableName;

        private bool isNewAddColumn = false;

        public IBuildTableSqlService SettingTableName(string TableName, string PrimaryKey)
        {
            CreateTableSql = CreateTableSQLTemplate.CreateTableHeadSql.Replace("{tableName}", TableName).Replace("{ColumnName}", PrimaryKey);
            PrimarykeySql = CreateTableSQLTemplate.PRIMARYKEYSQL.Replace("{tableName}", TableName).Replace("{ColumnName}", PrimaryKey);
            this.TableName = TableName;
            return this;
        }

        public IBuildTableSqlService AddColumn(string ColumnName, string Type)
        {
            if (string.IsNullOrWhiteSpace(TableName))
                throw new ArgumentNullException("TableName", "请先调用配置表名称方法[SetTableName]");
            if (ColumnSql.Contains($"[{ColumnName}]"))
                throw new ArgumentException(@"列名[{ColumnName}]已存在,请不要重复添加列名", "ColumnName");

            ColumnSql += $"{CreateTableSQLTemplate.ColumnTemplateSql.Replace("{ColumnName}", ColumnName).Replace("{TypeInfo}", Type).Replace("{tableName}", TableName)}";

            return this;
        }

        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="TableName"></param>
        /// <param name="ColumnName"></param>
        /// <param name="Type"></param>
        /// <returns></returns>
        /// <exception cref="ArgumentNullException"></exception>
        /// <exception cref="ArgumentException"></exception>
        public IBuildTableSqlService NewFieldColumn(string TableName, string ColumnName, string Type)
        {
            if (string.IsNullOrWhiteSpace(TableName))
                throw new ArgumentNullException("TableName", "请先调用配置表名称方法[SetTableName]");
            if (ColumnSql.Contains($"[{ColumnName}]"))
                throw new ArgumentException(@"列名[{ColumnName}]已存在,请不要重复添加列名", "ColumnName");

            ColumnSql += $"{CreateTableSQLTemplate.AddColumn.Replace("{ColumnName}", ColumnName).Replace("{TypeInfo}", Type).Replace("{tableName}", TableName)}";
            isNewAddColumn = true;
            return this;
        }

        public IBuildTableSqlService SettingDefaultValue(string ColumnName, string DefaultValueStr)
        {
            if (string.IsNullOrWhiteSpace(TableName))
                throw new ArgumentNullException("TableName", "请先调用配置表名称方法[SetTableName]");
            //if (string.IsNullOrWhiteSpace(ColumnName))
            //    throw new ArgumentNullException("ColumnName", "请录入正确的列名");
            if (string.IsNullOrEmpty(ColumnName) || string.IsNullOrEmpty(DefaultValueStr))
                return this;

            DefaultValueSQL = CreateTableSQLTemplate.DefaultValueTemplateSQL.Replace("{tableName}", TableName)
                                                                               .Replace("{ColumnName}", ColumnName)
                                                                               .Replace("{DefaultValue}", DefaultValueStr);
            return this;
        }

        public IBuildTableSqlService SettingColumnDescription(string ColumnName, string Description)
        {
            if (string.IsNullOrWhiteSpace(TableName))
                throw new ArgumentNullException("TableName", "请先调用配置表名称方法[SetTableName]");
            if (string.IsNullOrEmpty(ColumnName) || string.IsNullOrEmpty(Description))
                return this;
            SettingColumnDescriptionsql = CreateTableSQLTemplate.AddColumnDbDescriptionTemplate
                .Replace("{columnDescription}", Description)
                .Replace("{schema}", "dbo")
                .Replace("{tableName}", TableName)
                .Replace("{columnName}", ColumnName);
            return this;
        }

        public string BullSQL()
        {
            if (isNewAddColumn)
            {
                return CreateTableSql += ColumnSql; ;
            }
            if (!string.IsNullOrEmpty(ColumnSql))
                CreateTableSql += ColumnSql;

            if (!string.IsNullOrEmpty(PrimarykeySql))
                CreateTableSql += PrimarykeySql;

            if (!string.IsNullOrEmpty(DefaultValueSQL))
                CreateTableSql += DefaultValueSQL;

            if (!string.IsNullOrEmpty(SettingColumnDescriptionsql))
                CreateTableSql += SettingColumnDescriptionsql;

            return CreateTableSql + "  end";
        }
    }
}