﻿namespace OrBit.MESInterface.Infrastructure
{
    public interface IBuildTableSqlService
    {
        /// <summary>
        /// 设置表名与主键
        /// </summary>
        /// <param name="TableName"></param>
        /// <param name="PrimaryKey"></param>
        /// <returns></returns>
        public IBuildTableSqlService SettingTableName(string TableName, string PrimaryKey);

        /// <summary>
        /// 添加列
        /// </summary>
        /// <param name="ColumnName"></param>
        /// <param name="Type"></param>
        /// <returns></returns>
        public IBuildTableSqlService AddColumn(string ColumnName, string Type);

        /// <summary>
        /// 新增字段
        /// </summary>
        /// <param name="ColumnName"></param>
        /// <param name="Type"></param>
        /// <returns></returns>
        public IBuildTableSqlService NewFieldColumn(string TableName, string ColumnName, string Type);

        /// <summary>
        /// 列添加默认值
        /// </summary>
        /// <param name="ColumnName"></param>
        /// <param name="DefaultValueStr"></param>
        /// <returns></returns>

        public IBuildTableSqlService SettingDefaultValue(string ColumnName, string DefaultValueStr);

        /// <summary>
        /// 列添加说明
        /// </summary>
        /// <param name="ColumnName"></param>
        /// <param name="Description"></param>
        /// <returns></returns>

        public IBuildTableSqlService SettingColumnDescription(string ColumnName, string Description);

        /// <summary>
        /// 构建sql
        /// </summary>
        /// <returns></returns>
        public string BullSQL();
    }
}