﻿namespace OrBit.MESInterface.Infrastructure.SQLTemplate
{
    public class CreateTableSQLTemplate
    {
        /// <summary>
        /// 判断表是否存在模板SQL
        /// </summary>

        public const string TableIsExists = @"  if Exists(select top 1 * from sysObjects where Id=OBJECT_ID(N'{tableName}') and xtype='U')
								  select 'Y' AS 'ISExists'
								  else select 'N' AS 'ISExists'";

        /// <summary>
        /// 创建表部分sql
        /// </summary>
        public const string CreateTableHeadSql = @"
									if not Exists(select top 1 * from sysObjects where Id=OBJECT_ID(N'{tableName}') and xtype='U')
									begin
									CREATE TABLE [dbo].[{tableName}](
                                      [{ColumnName}] [nvarchar](36) NOT NULL
                                  ";

        /// <summary>
        /// 新增字段
        /// </summary>
        public const string AddColumn = "alter table [{tableName}] add {ColumnName} {TypeInfo}  null ";

        /// <summary>
        /// 创建表部分sql ，添加列
        /// </summary>
        public const string ColumnTemplateSql = @" ,[{ColumnName}] {TypeInfo} NULL";

        /// <summary>
        /// 修改列默认值模板SQL
        /// </summary>
        public const string DefaultValueTemplateSQL = @"  ALTER TABLE [dbo].[{tableName}] ADD  CONSTRAINT [DF_{{tableName}}_{ColumnName}]  DEFAULT ({DefaultValue}) FOR [{ColumnName}]
										  ";

        /// <summary>
        ///创建表部分sql 添加主键
        /// </summary>

        public const string PRIMARYKEYSQL = @" ,CONSTRAINT [PK_{tableName}] PRIMARY KEY CLUSTERED
                                  (
	                                  [{ColumnName}] ASC
                                  )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                  ) ON [PRIMARY]

								 ";

        /// <summary>
        /// 表结构信息
        /// </summary>
        public const string DBTableInfo = @"  SELECT d.name TableName,
                                                        a.name ColumnName,
                                                        CAST( (case when (SELECT count(*) FROM sysobjects
                                                         WHERE (name in (SELECT name FROM sysindexes
                                                         WHERE (id = a.id) AND (indid in
                                                         (SELECT indid FROM sysindexkeys
                                                         WHERE (id = a.id) AND (colid in
                                                         (SELECT colid FROM syscolumns WHERE (id = a.id) AND (name = a.name)))))))
                                                         AND (xtype = 'PK'))>0 then 1 else 0 end) AS bit)IsPKID,b.name ColumnType,
                                                         COLUMNPROPERTY(a.id,a.name,'PRECISION') as Columnlength,
                                                         isnull(COLUMNPROPERTY(a.id,a.name,'Scale'),0) as DecimalPlace,CAST(case when a.isnullable=1 then 1 else 0 end AS bit)  AllowedEmpty,
                                                         isnull(e.text,'') DefaultValue,isnull(g.[value], ' ') AS ColumnDescription
                                                         FROM  syscolumns a
                                                         left join systypes b on a.xtype=b.xusertype
                                                         inner join sysobjects d on a.id=d.id and d.xtype='U' and d.name<>'dtproperties'
                                                         left join syscomments e on a.cdefault=e.id
                                                         left join sys.extended_properties g on a.id=g.major_id AND a.colid=g.minor_id
                                                         left join sys.extended_properties f on d.id=f.class and f.minor_id=0
                                                 WHERE d.name='{tableName}' --如果只查询指定表,加上此条件
                                                 order by a.id,a.colorder";

        /// <summary>
        /// 添加表字段说明模板
        /// </summary>
        public const string AddColumnDbDescriptionTemplate = @"
if exists (
	select t.name as tname,c.name as cname, d.value as Description
	from sysobjects t
	left join syscolumns c
	on c.id=t.id and t.xtype='U' and t.name<>'dtproperties'
	left join sys.extended_properties d
	on c.id=d.major_id and c.colid=d.minor_id and d.name = 'MS_Description'
	where t.name = '{tableName}' and c.name = '{columnName}' and d.value is not null)
begin
	exec sys.sp_dropextendedproperty
    @name=N'MS_Description'
  , @level0type=N'SCHEMA'
  , @level0name=N'{schema}'
  , @level1type=N'TABLE'
  , @level1name=N'{tableName}'
  , @level2type=N'COLUMN'
  , @level2name=N'{columnName}'
end
go

exec sys.sp_addextendedproperty
    @name=N'MS_Description'
  , @value=N'{columnDescription}'
  , @level0type=N'SCHEMA'
  , @level0name=N'{schema}'
  , @level1type=N'TABLE'
  , @level1name=N'{tableName}'
  , @level2type=N'COLUMN'
  , @level2name=N'{columnName}'
go";

        /// <summary>
        /// 删除列说明
        /// </summary>
        public const string DropColumnDbDescriptionTemplate = @"
if exists (
	select t.name as tname,c.name as cname, d.value as Description
	from sysobjects t
	left join syscolumns c
	on c.id=t.id and t.xtype='U' and t.name<>'dtproperties'
	left join sys.extended_properties d
	on c.id=d.major_id and c.colid=d.minor_id and d.name = 'MS_Description'
	where t.name = '{tableName}' and c.name = '{columnName}' and d.value is not null)
begin
	exec sys.sp_dropextendedproperty
    @name=N'MS_Description'
  , @level0type=N'SCHEMA'
  , @level0name=N'{schema}'
  , @level1type=N'TABLE'
  , @level1name=N'{tableName}'
  , @level2type=N'COLUMN'
  , @level2name=N'{columnName}'
end
go";
    }
}