﻿using System;
using System.Collections.Generic;
using System.Data;

namespace OrBit.MESInterface.Infrastructure.CreateTable
{
    public enum CreateTableStatus
    {
        /// <summary>
        /// 表存在
        /// </summary>
        Exist,

        /// <summary>
        /// 创建成功
        /// </summary>
        Success,

        /// <summary>
        /// 创建失败
        /// </summary>
        Fail
    }

    public class TableModel
    {
        private string tableName;
        public string TableName { get => tableName; set => tableName = $"OrBit_Interface_middle_{value}"; }

        public string PrimaryKey { get; private set; }

        public TableModel(string TableName, string id = "")
        {
            this.TableName = TableName;
            this.PrimaryKey = tableName + "ID";
            if (!string.IsNullOrEmpty(id))
                GroupIDValue = id;
            else
                GroupIDValue = Guid.NewGuid().ToString();
        }

        public string GroupIDName { get; set; } = "GroupId";

        public string GroupIDValue { get; set; }

        public string GroupCreateTimeName { get; set; } = "GroupCreateTime";

        public DateTime GroupCreateTimeValue { get; set; } = DateTime.Now;

        /// <summary>
        /// 表创建的状态
        /// </summary>
        public CreateTableStatus CreateTableStatus { get; set; } = CreateTableStatus.Fail;

        /// <summary>
        /// 表创建失败的原因
        /// </summary>
        public string CreateTableFailMSG { get; set; }

        /// <summary>
        /// 需要创建的字段
        /// </summary>
        public IDictionary<string, string> ColumnDescription { get; set; } = new Dictionary<string, string>();

        /// <summary>
        /// 新增的列名
        /// </summary>
        public IDictionary<string, string> AlterColumnDescription { get; set; } = new Dictionary<string, string>();

        public DataTable Data { get; set; } = new DataTable();
    }
}