﻿using OrBit.MESInterface.Infrastructure.Explorer.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OrBit.MESInterface.Infrastructure.Explorer
{
    public class DefaultExplorerProvider : IExplorer
    {
        public List<CustomFileInfo> GetDirectoryAndFile(string FullName)
        {
            
            List<CustomFileInfo> items = new List<CustomFileInfo>(10);
            try
            {
                if (Directory.Exists(FullName))
                {
                   var item = (ExplorerItem)new DirectoryItem(FullName);
                    items= item.GetFilesSystemInfo();
                }
            }
            catch { }
            finally { }
            return items;
        }

        public List<DirectoryItem> GetDirectoryItem(string FullName)
        {
            List<DirectoryItem> items = new List<DirectoryItem>(10);
            try
            {
                if (Directory.Exists(FullName))
                {
                    string[] dirs = Directory.GetDirectories(FullName);
                    foreach (string dir in dirs)
                    {
                        var attributes = File.GetAttributes(dir);
                        if ((attributes & FileAttributes.Hidden) != FileAttributes.Hidden)
                            items.Add(new DirectoryItem(dir));
                    }
                }
            }
            catch { }
            finally { }
            return items;
        }

        public List<DriveItem> GetDriveItem()
        {
            List<DriveItem> items = new List<DriveItem>(10);
            string[] drives = Environment.GetLogicalDrives();
            foreach (string drive in drives)
                items.Add(new DriveItem(drive));
            return items;
        }
    }
}
