﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OrBit.MESInterface.Infrastructure.Explorer.Models
{
    /// <summary>
    /// 目录
    /// </summary>
    public class DirectoryItem : ExplorerItem
    {
        public DirectoryItem(string fullName) : base(fullName) { }
        public override List<ExplorerItem> GetDirectories()
        {
            List<ExplorerItem> items = new List<ExplorerItem>(10);
            try
            {
                if (Directory.Exists(FullName))
                {
                    string[] dirs = Directory.GetDirectories(FullName);
                    foreach (string dir in dirs)
                    {
                        var attributes = File.GetAttributes(dir);
                        if ((attributes & FileAttributes.Hidden) != FileAttributes.Hidden)
                            items.Add(new DirectoryItem(dir));
                    }
                }
            }
            catch { }
            finally { }
            return items;
        }
        protected override string GetDirectoryName(string path)
        {
            return Path.GetFileName(path);
        }
    }
}
