﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Volo.Abp;

namespace OrBit.MESInterface.Infrastructure.Extensions
{
    public  static class HttpContextAuthorityAuthentication
    {
        public static ExecutionResult BasicAuth(this HttpContext httpContext, string DBaccountName, string DBpassword)
        {
            var result = new ExecutionResult();
            var ip = httpContext.Connection.RemoteIpAddress;//Current.Request.UserHostAddress;
            string authHeader = httpContext.Request.Headers["Authorization"];

            if (authHeader != null && authHeader.StartsWith("Basic"))
            {
                //Extract credentials
                string encodedUsernamePassword = authHeader.Substring("Basic ".Length).Trim();
                Encoding encoding = Encoding.GetEncoding("iso-8859-1");
                string usernamePassword = encoding.GetString(Convert.FromBase64String(encodedUsernamePassword));
                int seperatorIndex = usernamePassword.IndexOf(':');
                var username = usernamePassword.Substring(0, seperatorIndex);
                var password = usernamePassword.Substring(seperatorIndex + 1);

              
                if (!Regex.IsMatch(username, @"^[A-Za-z0-9_]+$"))
                {
                  //  logger.LogInformation("Wrong user name format");
                    throw new UserFriendlyException($"Wrong user name format", "-1", logLevel: LogLevel.Error);
                  
                }

                //if (IsAuthorized(username, password))
              var ValidateUser= DBaccountName.Equals(username, StringComparison.InvariantCultureIgnoreCase)
                                && DBpassword.Equals(password);
                if (ValidateUser)
                {
                    result.code = ExecutionState.SUCCESS;
                    result.message = $"Authorized, user {username}";
                  
                    return result;
                }
                else
                {
                 //   logger.LogInformation($"Unauthorized, user {username} ");
                    throw new UserFriendlyException($"Unauthorized, user {username}", "-1", logLevel: LogLevel.Error);
                }
            }
            else
            {
                // var ex= new Exception("No Basic Auth Info");
              //  logger.LogInformation("No Basic Auth Info");
                //  var exceptionHandlingOptions = context.GetRequiredService<IOptions<AbpExceptionHandlingOptions>>().Value;
                //  var exceptionToErrorInfoConverter = context.GetRequiredService<IExceptionToErrorInfoConverter>();
                //  var remoteServiceErrorInfo = exceptionToErrorInfoConverter.Convert(ex, exceptionHandlingOptions.SendExceptionsDetailsToClients);

                //  remoteServiceErrorInfo.Code = "-1";
                //  remoteServiceErrorInfo.Message = "No Basic Auth Info";
                //  logger.LogException(ex, LogLevel.Error);
                //  context.Result = new ObjectResult(remoteServiceErrorInfo);
                throw new UserFriendlyException($"No Basic Auth Info", "-1", logLevel: LogLevel.Error);
            }
        }
    }
}
