﻿using Microsoft.Data.SqlClient;
using OrBit.MESInterface.Infrastructure.CreateTable;
using System.Collections.Generic;
using System.Data;
using System.Threading.Tasks;

namespace OrBit.MESInterface.Infrastructure.Extensions
{
    public interface IExetenRepository
    {
        Task<DataSet> ExecutionScript(string script, SqlParameter[] sqlParameters = default);

        Task BulkCopy<T>(IEnumerable<T> list);

        Task BulkCopy(DataTable dt);

        Task CreateTable(string sql);

        Task<IEnumerable<DBTableInfo>> QueryDBTableInfo(string sql, SqlParameter[] parameters = null);
        Task<T> ExecuteSqlResultT<T>(string sql, SqlParameter[] parameters = null) where T : class, new();
        Task<DataSet> ExecuteSql(string sql, SqlParameter[] parameters = null);
        Task<int> ExecuteSqlNonQueryAsync(string StoredProcedure, SqlParameter[] parameters = null);
        Task<DataSet> ExecuteStoredProcedureResultDataSet(string StoredProcedure, SqlParameter[] parameters = null);

        Task<DataTable> ExecuteSqlResultDataTable(string StoredProcedure, SqlParameter[] parameters = null);

        Task<List<T>> ExecuteSqlResultList<T>(string sql, SqlParameter[] parameters = null) where T : class, new();
        Task<int> ExecuteStoredProcedureNonQueryAsync(string StoredProcedure, SqlParameter[] parameters = null);
    }
}