using System.Configuration;
using System.ServiceModel;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.DependencyInjection.Extensions;
using OrBit.MESInterface.OrderVerifyWebService.EntiyFrameworkCore;
using OrBit.MESInterface.OrderVerifyWebService.Application;
using SoapCore;
using Volo.Abp;
using Volo.Abp.Application;
using Volo.Abp.AspNetCore.Mvc;
using Volo.Abp.Autofac;
using Volo.Abp.Domain;
using Volo.Abp.EntityFrameworkCore;
using Volo.Abp.EntityFrameworkCore.SqlServer;
using Volo.Abp.Modularity;
using Microsoft.AspNetCore.Mvc;
using OrBit.MESInterface.OrderVerifyWebService.Middleware;

namespace OrBit.MESInterface.OrderVerifyWebService.WebApi;

[DependsOn(
    typeof(AbpAutofacModule),
    typeof(AbpAspNetCoreMvcModule),
    typeof(AbpDddApplicationModule),
    typeof(AbpEntityFrameworkCoreModule),
    typeof(AbpEntityFrameworkCoreSqlServerModule)
    )]
public class AppModule : AbpModule
{
    public override void ConfigureServices(ServiceConfigurationContext context)
    {
        // Microsoft.Extensions.Configuration.IConfiguration
        var services = context.Services;
        var configuration = context.Services.GetConfiguration();

        //services.AddControllers();

        //services.AddEndpointsApiExplorer();

        ////services.AddSwaggerGen(
        ////    options =>
        ////    {
        ////        options.SwaggerDoc("v1", new OpenApiInfo { Title = "MESInterface API", Version = "v1" });
        ////        options.DocInclusionPredicate((docName, description) => true);
        ////        options.CustomSchemaIds(type => type.FullName);
        ////    }
        ////    );
        //Configure<MvcOptions>(options =>
        //{
        //    //var index = options.Filters.ToList().FindIndex(filter => filter is ServiceFilterAttribute attr && attr.ServiceType.Equals(typeof(AbpExceptionFilter)));
        //    //if (index > -1)
        //    //    options.Filters.RemoveAt(index);
        //    options.Filters.Add(typeof(GlobalExceptionFilter));
        //});
        services.TryAddSingleton<IMesOperate, MesOperate>();
        services.AddSoapCore();
        services.AddSoapServiceOperationTuner(new MyServiceOperationTuner());
        services.AddDbContext<MesInterfaceDbContext>(options =>
        {
            options.UseSqlServer(configuration.GetConnectionString("dev"));
        });
    }

    public override void OnPostApplicationInitialization(ApplicationInitializationContext context)
    {
        var env = context.GetEnvironment();
        var app = context.GetApplicationBuilder();
        //if (env.IsDevelopment())
        //{
        //    app.UseSwagger();
        //    app.UseSwaggerUI();
        //}

        //app.UseHttpsRedirection();

        //app.UseAuthorization();

      //  app.UseBasicauthCheck();
    }
}