namespace OrBit.MESInterface.OrderVerifyWebService.Application;

public enum AnalyticState
{
    /// <summary>
    /// 返回错误信息
    /// </summary>
    FAIL = -1,

    /// <summary>
    /// 请求成功，但是没有新数据
    /// </summary>
    OK = 1,

    /// <summary>
    /// 请求成功，返回新数据
    /// </summary>
    SUCCESS = 2,

    /// <summary>
    /// 数据保存成功
    /// </summary>
    SaveDataSuccess = 3,

    /// <summary>
    /// 数据保存业务表成功
    /// </summary>
    SaveTooBusinessTableSuccess = 4
}

public class AnalyticResult
{
    /// <summary>
    /// 解析状态 -1：返回错误信息;1:请求成功，但是没有新数据;2：请求成功，返回新数据;3:数据保存成功; 4：数据保存业务表成功
    /// </summary>

    public AnalyticResult()
    {
        code = AnalyticState.SUCCESS;
    }

    /// <summary>
    /// 构造函数
    /// </summary>
    /// <param name="_State">状态</param>
    /// <param name="_Message">消息</param>
    /// <param name="_Value">返回信息</param>
    /// <param name="_Result">返回信息2</param>
    public AnalyticResult(AnalyticState _State, string _Message, object _Value = null, dynamic _Result = null)
    {
        code = _State;
        message = _Message;
        details = _Value;
        data = _Result;
    }

    public AnalyticState code { get; set; }

    public string message { get; set; }

    public object details { get; set; }

    public dynamic data { get; set; }

    public string validationErrors { get; set; }
}