﻿using Autofac.Core;
using Microsoft.Extensions.Primitives;
using SoapCore.Extensibility;
using System.Text.RegularExpressions;
using System.Text;
using Volo.Abp;
using Microsoft.Extensions.Logging.Abstractions;

namespace OrBit.MESInterface.OrderVerifyWebService.Application
{
    public class MyServiceOperationTuner : IServiceOperationTuner
    {
        public void Tune(HttpContext httpContext, object serviceInstance, SoapCore.ServiceModel.OperationDescription operation)
        {
            //  var logger = context.GetService<ILogger<MyServiceOperationTuner>>(NullLogger<MyServiceOperationTuner>.Instance);
            if (operation.Name.Equals("Show"))
            {
                //   MyService service = serviceInstance as MyService;
                string result = string.Empty;

                string authHeader = httpContext.Request.Headers["Authorization"];

                //获取IP
                var ip = httpContext.Connection.RemoteIpAddress;//Current.Request.UserHostAddress;

                if (authHeader != null && authHeader.StartsWith("Basic"))
                {
                    //Extract credentials
                    string encodedUsernamePassword = authHeader.Substring("Basic ".Length).Trim();
                    Encoding encoding = Encoding.GetEncoding("iso-8859-1");
                    string usernamePassword = encoding.GetString(Convert.FromBase64String(encodedUsernamePassword));

                    int seperatorIndex = usernamePassword.IndexOf(':');
                    var username = usernamePassword.Substring(0, seperatorIndex);
                    var password = usernamePassword.Substring(seperatorIndex + 1);

                    var ActionName = operation.Name;

                    if (!Regex.IsMatch(username, @"^[A-Za-z0-9_]+$"))
                    {
                        //   logger.LogInformation("Wrong user name format");
                        throw new UserFriendlyException($"Wrong user name format", "-1", logLevel: LogLevel.Error);
                    }

                    //if (IsAuthorized(username, password))
                    if (ValidateUser(username, password))
                    {
                        //   logger.LogInformation($"Authorized, user {username}");

                        return;
                    }
                    else
                    {
                        // logger.LogInformation($"Unauthorized, user {username} ");
                        throw new UserFriendlyException($"Unauthorized, user {username}", "-1", logLevel: LogLevel.Error);
                    }

                    //  service.SetParameterForSomeOperation(result);
                }
            }
        }

        public bool ValidateUser(string accountName, string password)
        {
            //验证用户名密码

            return "sapuser".Equals(accountName, StringComparison.InvariantCultureIgnoreCase)
                   && "12345".Equals(password); ;
        }
    }
}