using Autofac;
using Autofac.Extensions.DependencyInjection;
using OrBit.MESInterface.OrderVerifyWebService;
using OrBit.MESInterface.OrderVerifyWebService.Application;
using OrBit.MESInterface.OrderVerifyWebService.WebApi;
using Serilog;
using SoapCore;
using System.Configuration;
using System.ServiceModel;

var builder = WebApplication.CreateBuilder(args);

Log.Logger = new SerilogConfiguration(builder.Configuration).CreateLogger();

Log.Information("Mes inteface be starting ...");

builder.Host.AddAppSettingsSecretsJson()
            .UseSerilog(Log.Logger, dispose: true)
            .UseAutofac();
await builder.AddApplicationAsync<AppModule>();

var app = builder.Build();

app.InitializeApplication();

app.UseSoapEndpoint<IMesOperate>("/Mes/MesService.asmx", new SoapEncoderOptions());

app.Run();